/*
 * This class is an auto-generated source file for a HAPI
 * HL7 v2.x standard structure class.
 *
 * For more information, visit: http://hl7api.sourceforge.net/
 */

package ca.uhn.hl7v2.model.v251.datatype;

import ca.uhn.hl7v2.model.Composite;
import ca.uhn.hl7v2.model.DataTypeException;
import ca.uhn.hl7v2.model.Message;
import ca.uhn.hl7v2.model.Type;
import ca.uhn.hl7v2.model.AbstractType;
import ca.uhn.log.HapiLogFactory;

/**
 * <p>Represents an HL7 MOC (Money and Code) data type. 
 * This type consists of the following components:</p>
 * <ul>
 * <li>Monetary Amount (MO)
 * <li>Charge Code (CE)
 * </ul>
 */
public class MOC extends AbstractType implements Composite {

    private Type[] data;

    /** 
     * Creates a new MOC type
     */
    public MOC(Message message) {
        super(message);
        init();
    }

    private void init() {
        data = new Type[2];    
        data[0] = new MO(getMessage());
        data[1] = new CE(getMessage());
    }


    /**
     * Returns an array containing the data elements.
     */
    public Type[] getComponents() { 
        return this.data; 
    }

    /**
     * Returns an individual data component.
     *
     * @param number The component number (0-indexed)
     * @throws DataTypeException if the given element number is out of range.
     */
    public Type getComponent(int number) throws DataTypeException { 

        try { 
            return this.data[number]; 
        } catch (ArrayIndexOutOfBoundsException e) { 
            throw new DataTypeException("Element " + number + " doesn't exist (Type " + getClass().getName() + " has only " + this.data.length + " components)"); 
        } 
    } 


    /**
     * Returns Monetary Amount (component #1).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public MO getMonetaryAmount() {
       MO ret = null;
       try {
          ret = (MO)getComponent(0);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    
    /**
     * Returns Monetary Amount (component #1).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public MO getMoc1_MonetaryAmount() {
       MO ret = null;
       try {
          ret = (MO)getComponent(0);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns Charge Code (component #2).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public CE getChargeCode() {
       CE ret = null;
       try {
          ret = (CE)getComponent(1);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    
    /**
     * Returns Charge Code (component #2).  This is a convenience method that saves you from 
     * casting and handling an exception.
     */
    public CE getMoc2_ChargeCode() {
       CE ret = null;
       try {
          ret = (CE)getComponent(1);
       } catch (DataTypeException e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem accessing known data type component - this is a bug.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }



}

