/*
 * This class is an auto-generated source file for a HAPI
 * HL7 v2.x standard structure class.
 *
 * For more information, visit: http://hl7api.sourceforge.net/
 */

package ca.uhn.hl7v2.model.v251.group;

import ca.uhn.hl7v2.model.v251.segment.*;

import ca.uhn.log.HapiLogFactory;
import ca.uhn.hl7v2.HL7Exception;
import ca.uhn.hl7v2.parser.ModelClassFactory;
import ca.uhn.hl7v2.parser.DefaultModelClassFactory;
import ca.uhn.hl7v2.model.AbstractMessage;
import ca.uhn.hl7v2.model.Group;
import ca.uhn.hl7v2.model.AbstractGroup;
import ca.uhn.hl7v2.model.GenericSegment;

/**
 * <p>Represents a MFN_M04_MF_CDM group structure (a Group object).
 * A Group is an ordered collection of message segments that can repeat together or be optionally in/excluded together.
 * This Group contains the following elements:  
 * </p>
 * <ul>
                 * <li>1: MFE (Master File Entry) <b> </b></li>
                 * <li>2: CDM (Charge Description Master) <b> </b></li>
                 * <li>3: PRC (Pricing) <b>optional repeating</b></li>
 * </ul>
 */
public class MFN_M04_MF_CDM extends AbstractGroup {

    /** 
     * Creates a new MFN_M04_MF_CDM group
     */
    public MFN_M04_MF_CDM(Group parent, ModelClassFactory factory) {
       super(parent, factory);
       init(factory);
    }

    private void init(ModelClassFactory factory) {
       try {
                          this.add(MFE.class, true, false);
                          this.add(CDM.class, true, false);
                          this.add(PRC.class, false, true);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error creating MFN_M04_MF_CDM - this is probably a bug in the source code generator.", e);
       }
    }

    /** 
     * Returns "2.5.1"
     */
    public String getVersion() {
       return "2.5.1";
    }



    /**
     * Returns
     * MFE (Master File Entry) - creates it if necessary
     */
    public MFE getMFE() { 
       MFE ret = null;
       try {
          ret = (MFE)this.get("MFE");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }




    /**
     * Returns
     * CDM (Charge Description Master) - creates it if necessary
     */
    public CDM getCDM() { 
       CDM ret = null;
       try {
          ret = (CDM)this.get("CDM");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }




    /**
     * Returns
     * the first repetition of 
     * PRC (Pricing) - creates it if necessary
     */
    public PRC getPRC() { 
       PRC ret = null;
       try {
          ret = (PRC)this.get("PRC");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }


    /**
     * Returns a specific repetition of
     * PRC (Pricing) - creates it if necessary
     *
     * @param rep The repetition index (0-indexed, i.e. the first repetition is at index 0)
     * @throws HL7Exception if the repetition requested is more than one 
     *     greater than the number of existing repetitions.
     */
    public PRC getPRC(int rep) { 
       PRC ret = null;
       try {
          ret = (PRC)this.get("PRC", rep);
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error accessing data - this is probably a bug in the source code generator.", e);
          throw new RuntimeException(e);
       }
       return ret;
    }

    /** 
     * Returns the number of existing repetitions of PRC 
     */ 
    public int getPRCReps() { 
        int reps = -1; 
        try { 
            reps = this.getAll("PRC").length; 
        } catch (HL7Exception e) { 
            String message = "Unexpected error accessing data - this is probably a bug in the source code generator."; 
            HapiLogFactory.getHapiLog(this.getClass()).error(message, e); 
            throw new RuntimeException(message);
        } 
        return reps; 
    } 

    /**
     * Inserts a specific repetition of PRC (Pricing)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public void insertPRC(PRC structure, int rep) throws HL7Exception { 
       super.insertRepetition("PRC", structure, rep);
    }


    /**
     * Inserts a specific repetition of PRC (Pricing)
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public PRC insertPRC(int rep) throws HL7Exception { 
       return (PRC)super.insertRepetition("PRC", rep);
    }


    /**
     * Removes a specific repetition of PRC (Pricing)
     * @see AbstractGroup#removeRepetition(String, int) 
     */
    public PRC removePRC(int rep) throws HL7Exception { 
       return (PRC)super.removeRepetition("PRC", rep);
    }



}

