/*
 * This class is an auto-generated source file for a HAPI
 * HL7 v2.x standard structure class.
 *
 * For more information, visit: http://hl7api.sourceforge.net/
 */

package ca.uhn.hl7v2.model.v251.segment;

// import ca.uhn.hl7v2.model.v251.group.*;
import ca.uhn.hl7v2.model.v251.datatype.*;
import ca.uhn.log.HapiLogFactory;
import ca.uhn.hl7v2.HL7Exception;
import ca.uhn.hl7v2.parser.ModelClassFactory;
import ca.uhn.hl7v2.parser.DefaultModelClassFactory;
import ca.uhn.hl7v2.model.AbstractMessage;
import ca.uhn.hl7v2.model.Group;
import ca.uhn.hl7v2.model.Type;
import ca.uhn.hl7v2.model.AbstractSegment;
import ca.uhn.hl7v2.model.Varies;

/**
 *<p>Represents an HL7 OM2 message segment (Numeric Observation). 
 * This segment has the following fields:</p>
 * <ul>
     * <li>OM2-1: Sequence Number - Test/Observation Master File (NM) <b>optional </b>
     * <li>OM2-2: Units of Measure (CE) <b>optional </b>
     * <li>OM2-3: Range of Decimal Precision (NM) <b>optional repeating</b>
     * <li>OM2-4: Corresponding SI Units of Measure (CE) <b>optional </b>
     * <li>OM2-5: SI Conversion Factor (TX) <b>optional </b>
     * <li>OM2-6: Reference (Normal) Range - Ordinal and Continuous Observations (RFR) <b>optional repeating</b>
     * <li>OM2-7: Critical Range for Ordinal and Continuous Observations (RFR) <b>optional repeating</b>
     * <li>OM2-8: Absolute Range for Ordinal and Continuous Observations (RFR) <b>optional </b>
     * <li>OM2-9: Delta Check Criteria (DLT) <b>optional repeating</b>
     * <li>OM2-10: Minimum Meaningful Increments (NM) <b>optional </b>
 * </ul>
 */
public class OM2 extends AbstractSegment {

    /** 
     * Creates a new OM2 segment
     */
    public OM2(Group parent, ModelClassFactory factory) {
       super(parent, factory);
       init(factory);
    }

    private void init(ModelClassFactory factory) {
       try {
                                  this.add(NM.class, false, 1, 4, new Object[]{ getMessage(), new Integer(0) }, "Sequence Number - Test/Observation Master File");
                                  this.add(CE.class, false, 1, 250, new Object[]{ getMessage(), new Integer(9999) }, "Units of Measure");
                                  this.add(NM.class, false, 0, 10, new Object[]{ getMessage(), new Integer(0) }, "Range of Decimal Precision");
                                  this.add(CE.class, false, 1, 250, new Object[]{ getMessage(), new Integer(9999) }, "Corresponding SI Units of Measure");
                                  this.add(TX.class, false, 1, 60, new Object[]{ getMessage(), new Integer(0) }, "SI Conversion Factor");
                                  this.add(RFR.class, false, 0, 250, new Object[]{ getMessage(), new Integer(0) }, "Reference (Normal) Range - Ordinal and Continuous Observations");
                                  this.add(RFR.class, false, 0, 205, new Object[]{ getMessage(), new Integer(0) }, "Critical Range for Ordinal and Continuous Observations");
                                  this.add(RFR.class, false, 1, 250, new Object[]{ getMessage(), new Integer(0) }, "Absolute Range for Ordinal and Continuous Observations");
                                  this.add(DLT.class, false, 0, 250, new Object[]{ getMessage(), new Integer(0) }, "Delta Check Criteria");
                                  this.add(NM.class, false, 1, 20, new Object[]{ getMessage(), new Integer(0) }, "Minimum Meaningful Increments");
       } catch(HL7Exception e) {
          HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected error creating OM2 - this is probably a bug in the source code generator.", e);
       }
    }



    /**
     * Returns
     * OM2-1: "Sequence Number - Test/Observation Master File" - creates it if necessary
     */
    public NM getSequenceNumberTestObservationMasterFile() { 
        NM ret = null;
        try {
            Type t = this.getField(1, 0);
            ret = (NM)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns
     * OM2-1: "Sequence Number - Test/Observation Master File" - creates it if necessary
     */
    public NM getOm21_SequenceNumberTestObservationMasterFile() { 
        NM ret = null;
        try {
            Type t = this.getField(1, 0);
            ret = (NM)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }



    /**
     * Returns
     * OM2-2: "Units of Measure" - creates it if necessary
     */
    public CE getUnitsOfMeasure() { 
        CE ret = null;
        try {
            Type t = this.getField(2, 0);
            ret = (CE)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns
     * OM2-2: "Units of Measure" - creates it if necessary
     */
    public CE getOm22_UnitsOfMeasure() { 
        CE ret = null;
        try {
            Type t = this.getField(2, 0);
            ret = (CE)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns all repetitions of Range of Decimal Precision (OM2-3).
     */
    public NM[] getRangeOfDecimalPrecision() {
        NM[] ret = null;
        try {
            Type[] t = this.getField(3);  
            ret = new NM[t.length];
            for (int i = 0; i < ret.length; i++) {
                ret[i] = (NM)t[i];
            }
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-3: "Range of Decimal Precision" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public NM getRangeOfDecimalPrecision(int rep) { 
        NM ret = null;
        try {
            Type t = this.getField(3, rep);
            ret = (NM)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-3: "Range of Decimal Precision" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public NM getOm23_RangeOfDecimalPrecision(int rep) { 
        NM ret = null;
        try {
            Type t = this.getField(3, rep);
            ret = (NM)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Inserts a repetition of
     * OM2-3: "Range of Decimal Precision" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public NM insertRangeOfDecimalPrecision(int rep) throws HL7Exception { 
        return (NM) super.insertRepetition(3, rep);
    }



    /**
     * Inserts a repetition of
     * OM2-3: "Range of Decimal Precision" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public NM insertOm23_RangeOfDecimalPrecision(int rep) throws HL7Exception { 
        return (NM) super.insertRepetition(3, rep);
    }


    /**
     * Removes a repetition of
     * OM2-3: "Range of Decimal Precision" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public NM removeRangeOfDecimalPrecision(int rep) throws HL7Exception { 
        return (NM) super.removeRepetition(3, rep);
    }


    /**
     * Removes a repetition of
     * OM2-3: "Range of Decimal Precision" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public NM removeOm23_RangeOfDecimalPrecision(int rep) throws HL7Exception { 
        return (NM) super.removeRepetition(3, rep);
    }




    /**
     * Returns
     * OM2-4: "Corresponding SI Units of Measure" - creates it if necessary
     */
    public CE getCorrespondingSIUnitsOfMeasure() { 
        CE ret = null;
        try {
            Type t = this.getField(4, 0);
            ret = (CE)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns
     * OM2-4: "Corresponding SI Units of Measure" - creates it if necessary
     */
    public CE getOm24_CorrespondingSIUnitsOfMeasure() { 
        CE ret = null;
        try {
            Type t = this.getField(4, 0);
            ret = (CE)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }



    /**
     * Returns
     * OM2-5: "SI Conversion Factor" - creates it if necessary
     */
    public TX getSIConversionFactor() { 
        TX ret = null;
        try {
            Type t = this.getField(5, 0);
            ret = (TX)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns
     * OM2-5: "SI Conversion Factor" - creates it if necessary
     */
    public TX getOm25_SIConversionFactor() { 
        TX ret = null;
        try {
            Type t = this.getField(5, 0);
            ret = (TX)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns all repetitions of Reference (Normal) Range - Ordinal and Continuous Observations (OM2-6).
     */
    public RFR[] getReferenceNormalRangeOrdinalAndContinuousObservations() {
        RFR[] ret = null;
        try {
            Type[] t = this.getField(6);  
            ret = new RFR[t.length];
            for (int i = 0; i < ret.length; i++) {
                ret[i] = (RFR)t[i];
            }
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-6: "Reference (Normal) Range - Ordinal and Continuous Observations" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public RFR getReferenceNormalRangeOrdinalAndContinuousObservations(int rep) { 
        RFR ret = null;
        try {
            Type t = this.getField(6, rep);
            ret = (RFR)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-6: "Reference (Normal) Range - Ordinal and Continuous Observations" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public RFR getOm26_ReferenceNormalRangeOrdinalAndContinuousObservations(int rep) { 
        RFR ret = null;
        try {
            Type t = this.getField(6, rep);
            ret = (RFR)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Inserts a repetition of
     * OM2-6: "Reference (Normal) Range - Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR insertReferenceNormalRangeOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.insertRepetition(6, rep);
    }



    /**
     * Inserts a repetition of
     * OM2-6: "Reference (Normal) Range - Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR insertOm26_ReferenceNormalRangeOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.insertRepetition(6, rep);
    }


    /**
     * Removes a repetition of
     * OM2-6: "Reference (Normal) Range - Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR removeReferenceNormalRangeOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.removeRepetition(6, rep);
    }


    /**
     * Removes a repetition of
     * OM2-6: "Reference (Normal) Range - Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR removeOm26_ReferenceNormalRangeOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.removeRepetition(6, rep);
    }



    /**
     * Returns all repetitions of Critical Range for Ordinal and Continuous Observations (OM2-7).
     */
    public RFR[] getCriticalRangeForOrdinalAndContinuousObservations() {
        RFR[] ret = null;
        try {
            Type[] t = this.getField(7);  
            ret = new RFR[t.length];
            for (int i = 0; i < ret.length; i++) {
                ret[i] = (RFR)t[i];
            }
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-7: "Critical Range for Ordinal and Continuous Observations" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public RFR getCriticalRangeForOrdinalAndContinuousObservations(int rep) { 
        RFR ret = null;
        try {
            Type t = this.getField(7, rep);
            ret = (RFR)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-7: "Critical Range for Ordinal and Continuous Observations" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public RFR getOm27_CriticalRangeForOrdinalAndContinuousObservations(int rep) { 
        RFR ret = null;
        try {
            Type t = this.getField(7, rep);
            ret = (RFR)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Inserts a repetition of
     * OM2-7: "Critical Range for Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR insertCriticalRangeForOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.insertRepetition(7, rep);
    }



    /**
     * Inserts a repetition of
     * OM2-7: "Critical Range for Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR insertOm27_CriticalRangeForOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.insertRepetition(7, rep);
    }


    /**
     * Removes a repetition of
     * OM2-7: "Critical Range for Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR removeCriticalRangeForOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.removeRepetition(7, rep);
    }


    /**
     * Removes a repetition of
     * OM2-7: "Critical Range for Ordinal and Continuous Observations" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public RFR removeOm27_CriticalRangeForOrdinalAndContinuousObservations(int rep) throws HL7Exception { 
        return (RFR) super.removeRepetition(7, rep);
    }




    /**
     * Returns
     * OM2-8: "Absolute Range for Ordinal and Continuous Observations" - creates it if necessary
     */
    public RFR getAbsoluteRangeForOrdinalAndContinuousObservations() { 
        RFR ret = null;
        try {
            Type t = this.getField(8, 0);
            ret = (RFR)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns
     * OM2-8: "Absolute Range for Ordinal and Continuous Observations" - creates it if necessary
     */
    public RFR getOm28_AbsoluteRangeForOrdinalAndContinuousObservations() { 
        RFR ret = null;
        try {
            Type t = this.getField(8, 0);
            ret = (RFR)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns all repetitions of Delta Check Criteria (OM2-9).
     */
    public DLT[] getDeltaCheckCriteria() {
        DLT[] ret = null;
        try {
            Type[] t = this.getField(9);  
            ret = new DLT[t.length];
            for (int i = 0; i < ret.length; i++) {
                ret[i] = (DLT)t[i];
            }
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-9: "Delta Check Criteria" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public DLT getDeltaCheckCriteria(int rep) { 
        DLT ret = null;
        try {
            Type t = this.getField(9, rep);
            ret = (DLT)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Returns a specific repetition of
     * OM2-9: "Delta Check Criteria" - creates it if necessary
     *
     * @param rep The repetition index (0-indexed)
     */
    public DLT getOm29_DeltaCheckCriteria(int rep) { 
        DLT ret = null;
        try {
            Type t = this.getField(9, rep);
            ret = (DLT)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }

    /**
     * Inserts a repetition of
     * OM2-9: "Delta Check Criteria" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public DLT insertDeltaCheckCriteria(int rep) throws HL7Exception { 
        return (DLT) super.insertRepetition(9, rep);
    }



    /**
     * Inserts a repetition of
     * OM2-9: "Delta Check Criteria" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public DLT insertOm29_DeltaCheckCriteria(int rep) throws HL7Exception { 
        return (DLT) super.insertRepetition(9, rep);
    }


    /**
     * Removes a repetition of
     * OM2-9: "Delta Check Criteria" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public DLT removeDeltaCheckCriteria(int rep) throws HL7Exception { 
        return (DLT) super.removeRepetition(9, rep);
    }


    /**
     * Removes a repetition of
     * OM2-9: "Delta Check Criteria" at a specific index
     *
     * @param rep The repetition index (0-indexed)
     * @throws HL7Exception If the rep is invalid (below 0, or too high for the allowable repetitions)
     */
    public DLT removeOm29_DeltaCheckCriteria(int rep) throws HL7Exception { 
        return (DLT) super.removeRepetition(9, rep);
    }




    /**
     * Returns
     * OM2-10: "Minimum Meaningful Increments" - creates it if necessary
     */
    public NM getMinimumMeaningfulIncrements() { 
        NM ret = null;
        try {
            Type t = this.getField(10, 0);
            ret = (NM)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }


    /**
     * Returns
     * OM2-10: "Minimum Meaningful Increments" - creates it if necessary
     */
    public NM getOm210_MinimumMeaningfulIncrements() { 
        NM ret = null;
        try {
            Type t = this.getField(10, 0);
            ret = (NM)t;
        } catch (ClassCastException cce) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", cce);
            throw new RuntimeException(cce);
        } catch (HL7Exception he) {
            HapiLogFactory.getHapiLog(this.getClass()).error("Unexpected problem obtaining field value.  This is a bug.", he);
            throw new RuntimeException(he);
        }
        return ret;
    }





    /** {@inheritDoc} */   
    protected Type createNewTypeWithoutReflection(int field) {
       switch (field) {
          case 0: return new NM(getMessage());
          case 1: return new CE(getMessage());
          case 2: return new NM(getMessage());
          case 3: return new CE(getMessage());
          case 4: return new TX(getMessage());
          case 5: return new RFR(getMessage());
          case 6: return new RFR(getMessage());
          case 7: return new RFR(getMessage());
          case 8: return new DLT(getMessage());
          case 9: return new NM(getMessage());
          default: return null;
       }
   }


}

